DL_VARIABLES_LOADED = nil;
DL_ENTERING_WORLD = nil;

DL_INIT_FUNCTIONS = {};
DL_INIT_FUNCTIONS_FRAMES = {};
DL_FRAME_FUNCTIONS = {};

DL_UNIT_BUFFCOUNT = 40;

DISCORDLIB_OPTIONSBG = { 
	bgFile="Interface/AddOns/DiscordLibrary/PlainBackdrop", 
	edgeFile="Interface/DialogFrame/UI-DialogBox-Border", 
	tile=true, 
	edgeSize=31, 
	tileSize=32, 
	insets={ left=11, right=12, top=12, bottom=11, }, 
}

DISCORDLIB_DBT = { 
	bgFile="Interface/AddOns/DiscordLibrary/PlainBackdrop", 
	edgeFile="Interface/DialogFrame/UI-DialogBox-Border", 
	tile=true, 
	edgeSize=32, 
	tileSize=32, 
	insets={ left=11, right=12, top=12, bottom=11, },
}

DISCORDLIB_PBT = { 
	bgFile="Interface/AddOns/DiscordLibrary/PlainBackdrop", 
	edgeFile="Interface/AddOns/DiscordLibrary/PlainBackdrop", 
	tile=false, 
	edgeSize=1, 
	insets={ left=1, right=1, top=1, bottom=1, },
}

DISCORDLIB_TTBT = { 
	bgFile="Interface/AddOns/DiscordLibrary/PlainBackdrop", 
	edgeFile="Interface/Tooltips/UI-Tooltip-Border", 
	tile=true, 
	edgeSize=16, 
	tileSize=16, 
	insets={ left=5, right=5, top=5, bottom=5, },
}

DISCORDLIB_SLIDERGB = { 
	bgFile="Interface/Buttons/UI-SliderBar-Background", 
	edgeFile="Interface/Buttons/UI-SliderBar-Border", 
	tile=true, 
	edgeSize=8, 
	tileSize=8, 
	insets={ left=3, right=3, top=6, bottom=6, },
}

function DUF_SetFrameUnitWatch(frame, watch)
-- /run for i=1, 4 do RegisterStateDriver(_G["PartyMemberFrame"..i], "visibility", "[group:raid] show; default") end
	if InCombatLockdown() then return end
	if watch then
		if not frame.IsUnitWatched then
			RegisterUnitWatch(frame, false)
			frame.IsUnitWatched = true
		end
	else
		if frame.IsUnitWatched then
			UnregisterUnitWatch(frame)
			frame.IsUnitWatched = nil
		end
	end
end

function DL_UseAction(action, checkcursor, selfcast)
	DL_LAST_ACTION = action;
end

function DL_PickupAction(action)
	DL_Update_ActionList();
end

function DL_PlaceAction(action)
	DL_Update_ActionList();
end

hooksecurefunc("UseAction", DL_UseAction)
hooksecurefunc("PickupAction", DL_PickupAction)
hooksecurefunc("PlaceAction", DL_PlaceAction)

function DiscordLib_Main_OnEvent(self, event, ...)
	local arg1 = ...
	if (event == "GROUP_ROSTER_UPDATE") then
		for i=1,4 do
			DL_Update_Auras("party"..i);
		end
--[[ BFA is checking for registering of obsolete events
	elseif (event == "CHAT_MSG_COMBAT_SELF_MISSES" or event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		if (string.find(arg1, DL_TEXT.Dodge)) then
			DL_TARGET_DODGED = 6;
		elseif (string.find(arg1, DL_TEXT.Parry)) then
			DL_TARGET_PARRIED = 6;
		elseif (string.find(arg1, DL_TEXT.Block)) then
			DL_TARGET_BLOCKED = 6;
		end
]]--
	elseif (event == "PET_ATTACK_START") then
		DL_PETATTACKING = true;
	elseif (event == "PET_ATTACK_STOP") then
		DL_PETATTACKING = nil;
	elseif (event == "UNIT_AURAS") then
		DL_Update_Auras("player");
	elseif (event == "UNIT_AURASTATE") then
		DL_Update_Auras ("player");
	elseif (event == "PLAYER_ENTER_COMBAT") then
		DL_ATTACKING = true;
		DL_INCOMBAT = true;
	elseif (event == "PLAYER_ENTERING_WORLD") then
		DL_ENTERING_WORLD = true;
		DL_ATTACKING = nil;
		DL_INCOMBAT = nil;
		DL_REGEN = true;
		if ( DL_VARIABLES_LOADED ) then
			DL_START_CHECKING_FRAME = true;
		end
	elseif (event == "PLAYER_LEAVE_COMBAT") then
		DL_ATTACKING = nil;
		if (DL_REGEN) then
			DL_INCOMBAT = nil;
		end
	elseif (event == "PLAYER_REGEN_DISABLED") then
		DL_REGEN = nil;
		DL_INCOMBAT = true;
	elseif (event == "PLAYER_REGEN_ENABLED") then
		DL_REGEN = true;
		if (not DL_ATTACKING) then
			DL_INCOMBAT = nil;
		end
	elseif (event == "PLAYER_TARGET_CHANGED") then
		DL_Update_Auras("target");
--	elseif (event == "RAID_ROSTER_UPDATE") then
	elseif (event == "GROUP_ROSTER_UPDATE") then
		for i=1,40 do
			DL_Update_Auras("raid"..i);
		end
	elseif (event == "UNIT_AURA") then
		if (arg1 ~= "mouseover" and arg1 ~= "player") then
			DL_Update_Auras(arg1);
		end
	elseif (event == "UNIT_PET") then
		DL_Update_Auras("pet");
		for i=1,4 do
			DL_Update_Auras("partypet"..i);
		end
	elseif (event == "UPDATE_SHAPESHIFT_FORMS") then
		DL_Update_Forms();
	elseif (event == "VARIABLES_LOADED") then
		DL_VARIABLES_LOADED = true;
		if ( DL_ENTERING_WORLD ) then
			DL_START_CHECKING_FRAME = true;
		end
	end
end

function DiscordLib_Main_OnLoad(self)
--	self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
--	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("PET_ATTACK_START");
	self:RegisterEvent("PET_ATTACK_STOP");
	self:RegisterEvent("PLAYER_ENTER_COMBAT");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
--	self:RegisterEvent("RAID_ROSTER_UPDATE");
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("UNIT_PET");
	self:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
	self:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
	self:RegisterEvent("VARIABLES_LOADED");

	SlashCmdList["DISCLIB"] = DL_Slash_Handler;
	SLASH_DISCLIB1 = "/disclib";
end

function DL_Slash_Handler(msg)
	if (msg == "nobuffchecking") then
		if (DiscordLibrary_Settings.disableBuffChecking) then
			DiscordLibrary_Settings.disableBuffChecking = nil;
			DL_Feedback("Discord Library's buff/debuff checking has been turned on.");
			DiscordLib_MainFrame:RegisterEvent("UNIT_AURA");
			DL_Update_Auras("player");
			DL_Update_Auras("pet");
			DL_Update_Auras("target");
			for i=1,4 do
			DL_Update_Auras("party"..i);
			DL_Update_Auras("partypet"..i);
			end
			for i=1,40 do
			DL_Update_Auras("raid"..i);
			end
		else
			DiscordLibrary_Settings.disableBuffChecking = 1;
			DL_Feedback("Discord Library's buff/debuff checking has been turned off.");
			DL_BUFFS = {};
			DL_DEBUFFS = {};
			DL_STATUS = {};
			DiscordLib_MainFrame:UnregisterEvent("UNIT_AURA");
			
		end
	end
end

function DiscordLib_Main_OnUpdate(self, elapsed)
	if (DL_TARGET_DODGED) then
		DL_TARGET_DODGED = DL_TARGET_DODGED - elapsed;
		if (DL_TARGET_DODGED < 0) then DL_TARGET_DODGED = nil; end
	end
	if (DL_TARGET_BLOCKED) then
		DL_TARGET_BLOCKED = DL_TARGET_BLOCKED - elapsed;
		if (DL_TARGET_BLOCKED < 0) then DL_TARGET_BLOCKED = nil; end
	end
	if (DL_TARGET_PARRIED) then
		DL_TARGET_PARRIED = DL_TARGET_PARRIED - elapsed;
		if (DL_TARGET_PARRIED < 0) then DL_TARGET_PARRIED = nil; end
	end
	if (self.inittimer) then
		self.inittimer = self.inittimer - elapsed;
		if (self.inittimer < 0) then
			self.inittimer = nil;
			DiscordLib_Initialize();
		end
	else
		if (DL_START_CHECKING_FRAME and (not DISCORDLIB_INITIALIZED)) then
			if (ZoneTextFrame:GetCenter()) then
				self.inittimer = 1;
			end
		end
	end
end

function DL_UnitName(unit)
	local name = UnitName(unit);
	if (name == UNKNOWNOBJECT or name == UKNOWNBEING) then
		return nil;
	else
		return name;
	end
end

function DiscordLib_Initialize()
	if (DISCORDLIB_INITIALIZED) then return; end
 	if (not DiscordLibrary_Settings) then
 		DiscordLibrary_Settings = {}
 	end
 	DL_Old_ColorPickerFrame_OnColorSelect = ColorPickerFrame:GetScript("OnColorSelect");
 	ColorPickerFrame:SetScript("OnColorSelect", function(frameName,r,g,b) DL_Old_ColorPickerFrame_OnColorSelect(frameName,r,g,b); DL_ColorBox_UpdateDisplay(); end);
	DiscordLib_Tooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
	DiscordLib_AuraTooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
	DL_Update_ActionList();
	DL_Init_AnchorFramesList();
	DL_Init_UnitsList();
	DL_TEXTURES_LIST = { {text="", value=""} };
	DL_Init_FontsList();
	DL_Update_Forms();
	DL_Update_Auras("player");
	DL_Update_Auras("pet");
	for i=1,4 do
		DL_Update_Auras("party"..i);
		DL_Update_Auras("partypet"..i);
	end
	for i=1,40 do
		DL_Update_Auras("raid"..i);
	end
	for index, initFunction in pairs(DL_FRAME_FUNCTIONS) do
		initFunction();
	end
	for index, initFunction in pairs(DL_INIT_FUNCTIONS) do
		initFunction(DL_INIT_FUNCTIONS_FRAMES[index]);
	end
	DISCORDLIB_INITIALIZED = true;
	DL_INIT_FUNCTIONS = nil;
end

function DiscordLib_RegisterInitFunc(func, delay)
	DL_INIT_FUNCTIONS_INDEX = DL_INIT_FUNCTIONS_INDEX + 1;
	DL_INIT_FUNCTIONS[DL_INIT_FUNCTIONS_INDEX] = func;
	DL_INIT_FUNCTIONS_FRAMES_INDEX = DL_INIT_FUNCTIONS_INDEX
	DL_INIT_FUNCTIONS_FRAMES[DL_INIT_FUNCTIONS_FRAMES_INDEX] = func;
end

function DiscordLib_RegisterFrameCreationFunc(func)
	DL_FRAME_FUNCTIONS_INDEX = DL_FRAME_FUNCTIONS_INDEX + 1
	DL_FRAME_FUNCTIONS[DL_FRAME_FUNCTIONS_INDEX] = func
end

function DL_ActionUsable(action)
	local cd = DL_CooldownLeft(action);
	if (cd > 0) then return; end
	local isUsable, notEnoughMana = IsUsableAction(action);
	if (not isUsable) then return; end
	if (notEnoughMana) then return; end
	local range = IsActionInRange(action);
	if (range ~= 0) then return true; end
end

function DL_AddToMenu(menu, text, value, desc)
	if (not text) then return; end
	if (not value) then value = text; end
	if (desc == 1) then
		desc = value;
		if (desc and string.len(desc) > 25) then
			desc = string.sub(desc, 1, 25).."\n"..string.sub(desc, 26);
		end
	end
	local found;
	for _, val in pairs(menu) do
		if (val.value == value) then
			found = 1;
			break;
		end
	end
	if (not found) then
		menu[#menu + 1] = { text=text, value=value, desc=desc };
	end
end

function DL_Alphabetic_Insert(table, value, subindex, start)
	local insertIndex;
	for i,v in pairs(table) do
		if ( strlower(value[subindex])<strlower(v[subindex]) or strlower(value[subindex])==strlower(v[subindex]) ) then
			if ((start and i >= start) or (not start)) then
				insertIndex = i;
				break;
			end
		end
	end
	tinsert(table, insertIndex, value);
end

function DL_AttackTarget()
	if (UnitHealth("target") and UnitHealth("target") <= 0) then return; end
	local __, class = UnitClass("player");
	if (class == "ROGUE" and DL_Get_ShapeshiftForm() == 1) then return; end
	if (class == "DRUID" and DL_Get_ShapeshiftForm() == 3) then return; end
	if (UnitCanAttack("player","target")) then
		if (not DL_ATTACKING) then
			AttackTarget(); 
		end
	end
end

function DL_CheckBuff(unit, buff)
	if (not DL_BUFFS[unit]) then return; end
	for i=1,DL_UNIT_BUFFCOUNT do
		if (DL_BUFFS[unit][i]) then
			if (string.find(DL_BUFFS[unit][i], buff, 1, true)) then
				return true;
			end
		else
			break;
		end
	end
end

function DL_CheckDebuff(unit, buff)
	if (not DL_DEBUFFS[unit]) then return; end
	for i=1,DL_UNIT_BUFFCOUNT do
		if (DL_DEBUFFS[unit][i]) then
			if (string.find(DL_DEBUFFS[unit][i], buff, 1, true)) then
				return i;
			end
		else
			break;
		end
	end
end

--function DL_CheckTempEnchant(buff)
--	if (not DL_BUFFS["player"]) then return; end
--	if (DL_BUFFS["Player"][i]) then
--		if (string.find(DL_BUFFS["player"][i], buff, 1, true)) then
--			return true;
--		end
--	end
--end

function DL_CheckStatus(unit, status)
	if (not DL_STATUS[unit]) then return 0; end
	local count = 0;
	for i=1,DL_UNIT_BUFFCOUNT do
		if (DL_STATUS[unit][i] == status) then
			count = count + 1;
		end
	end
	return count;
end

function DL_CleanUp_TempOptions(menu)
	if (menu.addedoptions) then
		for i in pairs(menu.addedoptions) do
			_G[menu.table][i] = nil;
		end
	end
end

function DL_ColorBox_UpdateColor(self)
	if (not self:GetText() or self:GetText() == "") then return; end
	local r, g, b, a = ColorPickerFrame:GetColorRGB();
	local id = self:GetID();
	if (id == 1) then
		r = self:GetNumber();
		if (not r) then r = 0; end
	elseif (id == 2) then
		g = self:GetNumber();
		if (not g) then g=0; end
	else
		b = self:GetNumber();
		if (not b) then b=0; end
	end
	ColorPickerFrame:SetColorRGB(r, g, b, a);
end

function DL_ColorBox_UpdateDisplay()
	if (DL_COLORBOX_FOCUS) then return; end
	local r, g, b = ColorPickerFrame:GetColorRGB();
	DL_RedBox:SetNumber(DL_round(r, 3));
	DL_GreenBox:SetNumber(DL_round(g, 3));
	DL_BlueBox:SetNumber(DL_round(b, 3));
end

function DL_Compare(val1, val2, method)
	if (method == 1) then
		if (val1 > val2) then return 1; else return; end
	elseif (method == 2) then
		if (val1 >= val2) then return 1; else return; end
	elseif (method == 3) then
		if (val1 == val2) then return 1; else return; end
	elseif (method == 4) then
		if (val1 <= val2) then return 1; else return; end
	elseif (method == 5) then
		if (val1 < val2) then return 1; else return; end
	end
end

function DL_CooldownLeft(action)
	local start, duration, enable = GetActionCooldown(action);
	if (start and duration and enable) then
		local remaining = duration - (GetTime() - start);
		if (remaining > 0) then
			return remaining;
		else
			return 0;
		end
	else
		return 0;
	end
end

function DL_Copy_Table(src, dest)
	for index, value in pairs(src) do
		if (type(value) == "table") then
			dest[index] = {};
			DL_Copy_Table(value, dest[index]);
		else
			dest[index] = value;
		end
	end
end

function DL_Debug(msg, r, g, b)
	if (r and g and b) then
		DEFAULT_CHAT_FRAME:AddMessage( msg, r, g, b);
	else
		DEFAULT_CHAT_FRAME:AddMessage( msg, 1.0, 0.0, 0.0 );
	end  
end

function DL_Feedback(msg)
	DEFAULT_CHAT_FRAME:AddMessage( msg, 1.0, 1.0, 0.0 )
end

function DL_Error(msg)
	if not DL_ScriptErrors:IsVisible() then
		DL_ScriptErrors_Message:SetText(msg)
		DL_ScriptErrors:Show()
	else
		DL_ERRORS_QUEUE[#DL_ERRORS_QUEUE + 1] = msg
	end
end

function DL_Get_ActionName(id, ranktoggle)
	if (not id) then return ""; end
	if (not HasAction(id)) then return ""; end
	DiscordLib_Tooltip:SetOwner(WorldFrame, "ANCHOR_NONE", 100, 100);
	DiscordLib_Tooltip:SetAction(id);
	local name, rank = "";
	if (DiscordLib_TooltipTextLeft1:IsShown()) then
		name = DiscordLib_TooltipTextLeft1:GetText();
	end
	if (DiscordLib_TooltipTextRight1:IsShown()) then
		rank = DiscordLib_TooltipTextRight1:GetText();
	end
	if (ranktoggle) then
		return name, rank;		
	else
		if (not rank) then
			return name;
		else
			return name.." ("..rank..")";
		end
	end
end

function DL_Get_Backdrop(index)
	if (index == 1) then
		return "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop",  true, 8, 1, 1, 1, 1, 1;
	elseif (index == 2) then
		return "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", "Interface\\Tooltips\\UI-Tooltip-Border", true, 16, 16, 5, 5, 5, 5;
	elseif (index == 3) then
		return "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", "Interface\\DialogFrame\\UI-DialogBox-Border", true, 32, 32, 11, 12, 12, 11;
	elseif (index == 4) then
		return "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", "Interface\\Buttons\\UI-SliderBar-Border", true, 8, 8, 3, 3, 6, 6;
	elseif (index == 5) then
		return "Interface\\AddOns\\DiscordLibrary\\PlainBackdrop", "Interface\\Glues\\Common\\Glue-Tooltip-Border", true, 16, 16, 10, 5, 4, 9;
	end
end

function DL_Get_Health(unit)
	local health = UnitHealth(unit);
	
end

function DL_Get_HealthMax(unit)
	local max_health = UnitHealthMax(unit);
	
end

function DL_Get_HexColor(r, g, b)
	return "|cFF"..string.format("%02X%02X%02X", r * 255.0, g * 255.0, b * 255.0);
end

function DL_Get_ItemName(bag, slot)
	local itemname, itemlink = "";
	if (slot) then
		itemlink = GetContainerItemLink(bag,slot);
	else
		itemlink = GetInventoryItemLink("player", bag);
	end
	if (itemlink) then
		itemname = string.sub(itemlink, string.find(itemlink, "[", 1, true) + 1, string.find(itemlink, "]", 1, true) - 1);
	end
	return itemname;
end

function DL_Get_MenuText(menu, value)
	for _, option in pairs(menu) do
		if (option.value == value) then
			return option.text;
		end
	end
	return "";
end

function DL_Get_LocalKBText(name, prefix, shorten)
	if (not prefix) then
		prefix = "KEY_";
	end
	local tempName = name;
	local i = strfind(name, "-");
	local dashIndex = nil;
	while ( i ) do
		if ( not dashIndex ) then
			dashIndex = i;
		else
			dashIndex = dashIndex + i;
		end
		tempName = strsub(tempName, i + 1);
		i = strfind(tempName, "-");
	end

	local modKeys = '';
	if ( not dashIndex ) then
		dashIndex = 0;
	else
		modKeys = strsub(name, 1, dashIndex);
	end

	local variablePrefix = prefix;
	if ( not variablePrefix ) then
		variablePrefix = "";
	end
	local localizedName = nil;
	if ( IsMacClient() ) then
		localizedName = _G[variablePrefix..tempName.."_MAC"];
	end
	if ( not localizedName ) then
		localizedName = _G[variablePrefix..tempName];
	end
	if ( not localizedName ) then
		localizedName = tempName;
	end

	local kbtext = modKeys..localizedName;
	if (shorten) then
		kbtext = string.upper(kbtext);
		kbtext = string.gsub(kbtext, "SHIFT", "S");
		kbtext = string.gsub(kbtext, "CTRL", "C");
		kbtext = string.gsub(kbtext, "ALT", "A");
		kbtext = string.gsub(kbtext, "MOUSE BUTTON", "MB");
		kbtext = string.gsub(kbtext, "BUTTON1", "MB1");
		kbtext = string.gsub(kbtext, "BUTTON2", "MB2");
		kbtext = string.gsub(kbtext, "BUTTON3", "MB3");
		kbtext = string.gsub(kbtext, "BUTTON4", "MB4");
		kbtext = string.gsub(kbtext, "BUTTON5", "MB5");
		kbtext = string.gsub(kbtext, "MIDDLE MOUSE", "MM");
		kbtext = string.gsub(kbtext, "NUM PAD", "NP");
	end

	return kbtext;
end

function DL_GetBindingText(index, prefix, shorten)
	local key1,key2 = DAB_GetBindingKey(index)
	if not key1 then
		key1 = ""
	else
		key1 = DL_Get_LocalKBText(key1,prefix,shorten)
	end
	if not key2 then
		key2 = ""
	else
		key2 = DL_Get_LocalKBText(key2,prefix,shorten)
	end
	return key1,key2
end

function DL_Get_Offsets(frame, baseframe, attachpoint, attachto)
	local x1, y1 = DL_Get_Position(frame, attachpoint);
	local x2, y2 = DL_Get_Position(baseframe, attachto);
	local xoffset, yoffset;
	if (x1 and x2 and y1 and y2) then
		local es1, es2 = 1, 1;
		if (baseframe.GetEffectiveScale) then
			es1 = baseframe:GetEffectiveScale();
		end
		if (frame.GetEffectiveScale) then
			es2 = frame:GetEffectiveScale();
		end
		xoffset = DL_round(x1 - x2 * es1 / es2, 2);
		yoffset = DL_round(y1 - y2 * es1 / es2, 2);
	end
	return xoffset, yoffset;
end

function DL_Get_Position(frame, attach)
	if (frame.GetCenter and (not frame:GetCenter())) then
		return;
	end
	local __, x, y;
	if (attach == "TOPLEFT") then
		x = frame:GetLeft();
		y = frame:GetTop();
	elseif (attach == "TOP") then
		x = frame:GetCenter();
		y = frame:GetTop();
	elseif (attach == "TOPRIGHT") then
		x = frame:GetRight();
		y = frame:GetTop();
	elseif (attach == "LEFT") then
		x = frame:GetLeft();
		__, y = frame:GetCenter();
	elseif (attach == "CENTER") then
		x, y = frame:GetCenter();
	elseif (attach == "RIGHT") then
		x = frame:GetRight();
		__, y = frame:GetCenter();
	elseif (attach == "BOTTOMLEFT") then
		x = frame:GetLeft();
		y = frame:GetBottom();
	elseif (attach == "BOTTOM") then
		x = frame:GetCenter();
		y = frame:GetBottom();
	elseif (attach == "BOTTOMRIGHT") then
		x = frame:GetRight();
		y = frame:GetBottom();
	end
	x = DL_round(x, 2);
	y = DL_round(y, 2);
	return x, y;
end

function DL_Get_ShapeshiftForm()
	for i=1,GetNumShapeshiftForms() do
		local __, __, isActive = GetShapeshiftFormInfo(i);
		if isActive == 1 then return i; end
	end
	return 0;
end

function DL_Hook(func, prefix)
	_G[prefix.."_Old_"..func] =  _G[func];
	_G[func] =  _G[prefix.."_"..func];
end

function DL_Init_AnchorFramesList()
	DL_ANCHOR_FRAMES = {};
	DL_ANCHOR_FRAMES[1] = { text = "UIParent", value="UIParent" };
end

function DL_Init_CheckBox(frame, setting)
	if (setting) then
		frame:SetChecked(true);
	else
		frame:SetChecked(false);
	end
end

function DL_Init_ColorPicker(frame, color)
	if (not color) then
		color = {r=1, g=1, b=1};
	end
	frame:SetBackdropColor(color.r, color.g, color.b);
end

function DL_Init_EditBox(frame, text)
	if (not text) then
		text = "";
	end
	frame.prevvalue = text;
	frame:SetText(text);
end

function DL_Init_FontsList()
	DL_FONTS_LIST = {};
	DL_FONTS_LIST[1] = { text="Fonts\\FRIZQT__.TTF", value="Fonts\\FRIZQT__.TTF", desc="Fonts\\FRIZQT__.TTF" };
	DL_FONTS_LIST[2] = { text="Fonts\\ARIALN.TTF", value="Fonts\\ARIALN.TTF", desc="Fonts\\ARIALN.TTF" };
	DL_FONTS_LIST[3] = { text="Fonts\\skurri.ttf", value="Fonts\\skurri.ttf", desc="Fonts\\skurri.ttf" };
	DL_FONTS_LIST[4] = { text="Fonts\\MORPHEUS.ttf", value="Fonts\\MORPHEUS.ttf", desc="Fonts\\MORPHEUS.ttf" };
end

function DL_Init_MenuControl(frame, setting, override)
	local text;
	for _, value in pairs(_G[frame.table]) do
		if (value.value == setting) then
			text = value.text;
			break;
		end
	end
	if ((not text) and frame.addoptions) then
		for _, value in pairs(frame.addoptions) do
			if (value.value == setting) then
				text = value.text;
				break;
			end
		end
	end
	if (not text) then
		if (override) then
			text = setting;
			if (not text) then
				text = "";
			end
		else
			text = "";
		end
	end
	_G[frame:GetName().."_Setting"]:SetText(text);
end

function DL_Init_Slider(frame, setting)
	if (string.find(frame:GetName(), "DFM") and (not setting)) then
		_G[frame:GetName().."_Display"]:SetText("");
		return;
	end
	if (frame.scale) then
		setting = setting * frame.scale;
	end
	local min, max = frame:GetMinMaxValues();
	_G[frame:GetName().."_Display"]:SetText(setting);
	if (setting < min or setting > max) then
		return;
	end
	frame:SetValue(setting);
end

function DL_Init_TabButton(self, text, selected, func, checked) -- Fizzlemizz: DAB fixed
	_G[self:GetName().."_Border"]:SetVertexColor(.4, 0, 0);
	_G[self:GetName().."_Text"]:SetText(text);
	self.selected = selected;
	self.clickFunc = func;
	if (checked) then
		_G[self:GetName().."_Text"]:SetTextColor(1, 0, 0);
		_G[self:GetName().."_Background"]:SetVertexColor(1, 1, 0);
		if (selected) then
			_G[selected] = self:GetName();
		end
	else
		_G[self:GetName().."_Background"]:SetVertexColor(0, 0, 0);
	end
end

function DL_Init_UnitsList()
	DL_UNITS_LIST = {};
	DL_UNITS_LIST[1] = {text=""};
	DL_UNITS_LIST[2] = {text="player (you)", value="player"};
	DL_UNITS_LIST[3] = {text="pet", value="pet"};
	DL_UNITS_LIST[4] = {text="target", value="target"};
	for i=1,4 do
		DL_UNITS_LIST[i + 4] = {text="party"..i, value="party"..i};
		DL_UNITS_LIST[i + 8] = {text="partypet"..i, value="partypet"..i};
	end
	for i=1,40 do
		DL_UNITS_LIST[i + 12] = {text="raid"..i, value="raid"..i};
	end
	DL_UNITS_LIST[53] = {text="focus", value="focus"};
end

function DL_IsMouseOver(frame)
	local lowx = frame:GetLeft();
	local highx = frame:GetRight();
	local lowy = frame:GetBottom();
	local highy = frame:GetTop();
	if (not lowx or not highx or not lowy or not highy) then return; end
	local x, y = GetCursorPosition();
	x = x  / UIParent:GetScale();
	y = y / UIParent:GetScale();
	if (x < lowx or x > highx) then
		return nil;
	end
	if (y < lowy or y > highy) then
		return nil;
	end
	return true;
end

function DL_Layout_VerticalFrames(base, num, onClick)
	local button, prev;
	if (onClick) then
		_G[base..1]:SetScript("OnClick", onClick);
	end
	for i=2, num do
		button = _G[base..i];
		prev = _G[base..(i - 1)];
		button:ClearAllPoints();
		button:SetPoint("TOP", prev, "BOTTOM", 0, 0);
		if (onClick) then
			button:SetScript("OnClick", onClick);
		end
	end
end

function DL_Layout_Menu(menu, clickFunc)
	local button, button2;
	if (clickFunc) then
		_G[menu.."_Option1"]:SetScript("OnClick", clickFunc);
	end
	for i=2, _G[menu].count do
		button = _G[menu.."_Option"..i];
		button2 = menu.."_Option"..(i - 1);
		button:ClearAllPoints();
		button:SetPoint("TOPLEFT", button2, "BOTTOMLEFT", 0, 0);
		if (clickFunc) then
			button:SetScript("OnClick", clickFunc);
		end
	end
end

function DL_Layout_ScrollButtons(base, num, onClick)
	local button, prev;
	if (onClick) then
		_G[base..1]:SetScript("OnClick", onClick);
--		_G[base.."1Highlight"]:SetVertexColor(1, 0, 1, 1);
--		_G[base.."1Checked"]:SetVertexColor(.7, .7, 0, 1);
		_G[base.."1Checked"]:SetVertexColor(0, 0, 0, 1);
	end
	for i=2, num do
		button = _G[base..i];
		prev = _G[base..(i - 1)];
		button:ClearAllPoints();
		button:SetPoint("TOP", prev, "BOTTOM");
		if (onClick) then
			button:SetScript("OnClick", onClick);
--			_G[base..i.."Highlight"]:SetVertexColor(1, 0, 1, 1);
--			_G[base..i.."Checked"]:SetVertexColor(.7, .7, 0, 1);
			_G[base..i.."Checked"]:SetVertexColor(0, 0, 0, 1);
		end
	end
end

function DL_Menu_Timeout(self, elapsed)
	if not self.mainWindow then
		self.mainWindow = _G[self.checkParent]
	else
		if not self.mainWindow:IsVisible() then
			self.timer = nil
			self:Hide()
			return
		end
	end
	if (self.timer) then
		self.timer = self.timer - elapsed
		if (self.timer < 0) then
			self.timer = nil
			self:Hide()
		end
	end
end

function DL_NudgeButton_OnLoad(self)
	if (self:GetID() == 0) then
		self:SetText(0);
	elseif (self:GetID() == 1) then
		self:SetText("^");
	elseif (self:GetID() == 2) then
		self:SetText("v");
	elseif (self:GetID() == 3) then
		self:SetText("<");
	elseif (self:GetID() == 4) then
		self:SetText(">");
	elseif (self:GetID() == 5) then
		self:SetText("-");
	elseif (self:GetID() == 6) then
		self:SetText("+");
	elseif (self:GetID() == 7) then
		self:SetText("R");
	elseif (self:GetID() == 8) then
		self:SetText("L");
	end
	self:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp");
end

function DL_PetAttack()
	if (DL_PETATTACKING) then return; end
	if (not UnitName("target")) then return; end
	if (not UnitCanAttack("pet", "target")) then return; end
	PetAttack();
end

function DL_round(number, precision)
	if (precision > 0) then
		number = number * 10 ^ precision;
	end
	local remainder = number - math.floor(number);
	if (remainder >= .5) then
		number = math.floor(number) + 1;
	else
		number = math.floor(number);
	end
	if (precision > 0) then
		number = number / 10 ^ precision;
	end
	return number;
end

function DL_ScriptErrors_OK_OnClick()
	if (DL_ERRORS_QUEUE[1]) then
		DL_ScriptErrors_Message:SetText(DL_ERRORS_QUEUE[1]);
		table.remove(DL_ERRORS_QUEUE, 1);
	else
		DL_ScriptErrors:Hide();
	end
end

function DL_Set_Anchor(self, subframe, xoffset, yoffset, attachpoint, attachto, center, frame)
	if (not frame) then
		frame = self;
	end
	if (not attachpoint) then
		attachpoint = "TOPLEFT";
	end
	if (not attachto) then
		attachto = "BOTTOMLEFT";
	end
	xoffset = _G[frame:GetName().."_Label"]:GetWidth() + xoffset + 5;
	if (center) then
		xoffset = xoffset / 2;
	end
	frame:ClearAllPoints();
	frame:SetPoint(attachpoint, frame:GetParent():GetName()..subframe, attachto, xoffset, yoffset);
end

function DL_Set_Label(self, text)
	_G[self:GetName().."_Label"]:SetText(text);
end

function DL_Set_OptionsTitle(frame, texture, version)
	_G[frame.."_TitleFrame_Title"]:SetTexture("Interface\\AddOns\\"..texture);
	_G[frame.."_TitleFrame_Title"]:SetAlpha(1);
	_G[frame.."_TitleFrame_Version"]:SetText("v. "..version);
	_G[frame.."_TitleFrame_URL"]:SetText("www.wowinterface.com");
end

function DL_Set_Timer(id, seconds)
	if (not DL_TIMERS) then DL_TIMERS = {}; end
	DL_TIMERS[id] = seconds;
end

function DL_Show_Menu(self, toggle) -- Fizzlefixed
	local parentcontrol = self -- FizzleFixed
	if (toggle) then
		parentcontrol = self:GetParent();
	end
	local menu = _G[parentcontrol.menu];
	if (menu:IsVisible()) then
		menu:Hide();
		DL_CleanUp_TempOptions(menu);
		return;
	end
	if (parentcontrol.addoptions) then
		menu.addedoptions = {};
		for i,v in pairs(parentcontrol.addoptions) do
			tinsert(_G[parentcontrol.table], v);
			menu.addedoptions[#_G[parentcontrol.table]] = 1;
		end
	else
		menu.addedoptions = nil;
	end
	if (not menu.scrollMenu) then
		local count = 0;
		local widest = 0;
		for _, value in pairs(_G[parentcontrol.table]) do
			count = count + 1;
			_G[parentcontrol.menu.."_Option"..count]:Show();
			_G[parentcontrol.menu.."_Option"..count.."_Text"]:SetText(value.text);
			_G[parentcontrol.menu.."_Option"..count].value = value.value;
			_G[parentcontrol.menu.."_Option"..count].desc = value.desc;
			local width = _G[parentcontrol.menu.."_Option"..count.."_Text"]:GetWidth();
			if (width > widest) then
				widest = width;
			end
		end
		for i=1, menu.count do
			if (i <= count) then
				_G[parentcontrol.menu.."_Option"..i]:SetWidth(widest);
			else
				_G[parentcontrol.menu.."_Option"..i]:Hide();			
			end
		end
		menu:SetWidth(widest + 20);
		menu:SetHeight(count * 15 + 20);
	end
	menu:ClearAllPoints();
	local frame = parentcontrol:GetName();
	menu:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 0, 0);
	if (menu:GetBottom() < UIParent:GetBottom()) then
		local yoffset = UIParent:GetBottom() - menu:GetBottom();
		menu:ClearAllPoints();
--		menu:SetPoint("TOPLEFT", parentcontrol:GetName().."_Setting", "BOTTOMLEFT", 0, yoffset);
		menu:SetPoint("TOPRIGHT", parentcontrol:GetName().."_Setting", "BOTTOMLEFT", 0, yoffset);
	end
	menu:Show();
	menu.table = parentcontrol.table;
	menu.index = parentcontrol.index;
	menu.subindex = parentcontrol.subindex;
	menu.subindex2 = parentcontrol.subindex2;
	menu.miscindex = parentcontrol.miscindex;
	menu.initFunc = parentcontrol.initFunc;
	menu.settingType = parentcontrol.settingType;
	menu.controlbox = parentcontrol:GetName().."_Setting";
	menu.cboxbase = parentcontrol:GetName();
	if (menu.scrollMenu) then
		for i=1, 10 do
			_G[menu:GetName().."_Button"..i]:SetChecked(false);
		end
		parentcontrol = _G[menu:GetName().."_ScrollFrame"];
		_G[menu:GetName().."_ScrollFrameScrollBar"]:SetValue(0);
		_G[menu:GetName().."_ScrollFrame"].offset = 0;
		menu.updateFunc(parentcontrol);
	end
end

function DL_Sort(origTable)
	local function sortf(a, b)
		if ( strlower(a)<strlower(b) ) then
			return true;
		elseif ( strlower(a)==strlower(b) and a<b ) then
			return true;
		end
	end
	table.sort(origTable, sortf);
end

function DL_SortKeys(origTable)
	local a = {};
	for n in pairs(origTable) do
		table.insert(a, n);
	end
	DL_Sort(a, sortf);
	return a;
end

function DL_TabButton_OnClick(self)
	local selected = _G[self.selected];
	if (selected) then
		_G[selected]:SetChecked(false);
		_G[selected.."_Background"]:SetVertexColor(0, 0, 0);
		_G[selected.."_Text"]:SetTextColor(1, 1, 0);
	end
	self:SetChecked(true);
	_G[self:GetName().."_Background"]:SetVertexColor(1, 1, 0);
	_G[self:GetName().."_Text"]:SetTextColor(1, 0, 0);
	if (self.selected) then
		_G[self.selected] = self:GetName();
	end
	if (self.clickFunc) then
		self.clickFunc(self:GetID());
	end
end

function DL_Update_Auras(unit)
	if (DiscordLibrary_Settings and DiscordLibrary_Settings.disableBuffChecking) then
		return;
	end
	if (not DL_BUFFS[unit]) then
		DL_BUFFS[unit] = {};
	end
	if (not DL_DEBUFFS[unit]) then
		DL_DEBUFFS[unit] = {};
	end	
	if (not DL_STATUS[unit]) then
		DL_STATUS[unit] = {};
	end
	if ((not UnitExists(unit)) or (not UnitName(unit))) then return; end
	for i=1,DL_UNIT_BUFFCOUNT do
		if (UnitBuff(unit, i)) then
			DiscordLib_AuraTooltip:SetUnitBuff(unit, i);
			if (DiscordLib_AuraTooltipTextLeft1:IsShown()) then
				DL_BUFFS[unit][i] = DiscordLib_AuraTooltipTextLeft1:GetText();
			else
				DL_BUFFS[unit][i] = "";
			end
		else
			DL_BUFFS[unit][i] = "";
		end
		if (UnitDebuff(unit, i)) then
			DiscordLib_AuraTooltip:SetUnitDebuff(unit, i);
			if (DiscordLib_AuraTooltipTextLeft1:IsShown()) then
				DL_DEBUFFS[unit][i] = DiscordLib_AuraTooltipTextLeft1:GetText();
			else
				DL_DEBUFFS[unit][i] = "";
			end
			if (DiscordLib_AuraTooltipTextRight1:IsShown()) then
				DL_STATUS[unit][i] = DiscordLib_AuraTooltipTextRight1:GetText();
			else
				DL_STATUS[unit][i] = "";
			end
		else
			DL_DEBUFFS[unit][i] = "";
			DL_STATUS[unit][i] = "";
		end
	end
end

function DL_Update_Forms()
	DL_FORMS = {};
	local __, class = UnitClass("player");
	if (class ~= "WARRIOR") then
		DL_FORMS[0] = { text=DL_TEXT.Humanoid, value=0 };
	end
	for i=1,GetNumShapeshiftForms() do
		local __, name = GetShapeshiftFormInfo(i);
		DL_FORMS[i] = { text=name, value=i };
	end
end

function DL_Update_Timers(elapsed)
	if (not DL_TIMERS) then return; end
	for k,v in pairs(DL_TIMERS) do
		DL_TIMERS[k] = v - elapsed;
	end
end

function DL_Update_ActionList()
	DL_ACTIONS = {};
	for i=1, 120 do
		DL_ACTIONS[i] = { text="["..i.."] "..DL_Get_ActionName(i), value=i };
	end
end

function DUF_FormatLargeValue(v) 
	if v < 9999 then
		return v
	elseif v < 999999 then
		return string.format("%.1fk", v / 1000)
	else
		return string.format("%.2fm", v / 1000000)
	end
end
